rizq_sanjaya_app/urls.py
from django.urls import path, include
from .views import *
from django.contrib.auth import views as auth_views


app_name = 'profile'
urlpatterns = [
    # path('', admin.index, name='home'),
    ################################################# PATH URL UNTUK ADMIN################################################# 
    path('', include(
        [
            path('', admin.index, name='admin_home'),
            path('verification/', user.verification, name='admin_verification'),
            path('send_verification/', user.send_verification, name='admin_send_verification'),
            path('email/verify/<uidb64>/<token>/',user.email_verify, name='admin_email_verify'),

          
            # USERS
            path('user/', include(
                [
                    path('', user.admin_index, name='admin_user'),
                    path('create/', user.create, name='admin_user_create'),
                    path('password/edit/', user.edit_password, name='admin_user_password_edit'),
                    path('profile/edit/<str:username>/', user.edit_profile, name='admin_user_edit'),
                    path('avatar/edit/<str:username>/', user.edit_avatar, name='admin_user_avatar_edit'),
                    path('detail/', user.admin_detail, name='admin_user_detail'),
                    path('soft_delete/<str:username>/', user.softDelete, name='admin_user_soft_delete'),
                    path('permanent_delete/<str:slug>/', user.permanentDelete, name='admin_user_permanent_delete'),
                    path('restore/<str:username>/', user.restore, name='admin_user_restore'),
                    path('edit_role/', user.edit_role, name='admin_user_edit_role'),
                    path('non_aktif/<str:id>/', user.non_aktif, name='non_aktif'),
                    path('re_aktif/<str:id>/', user.re_aktif, name='aktif'),
                ]
            )),

            # SETTING APLIKASI
            path('setting/', include(
                [
                    # path('', user.admin_index, name='admin_setting'),
                    path('running_text/', setting.admin_index_running_text, name='admin_setting_running_text'),
                    path('running_text/edit/', setting.admin_index_running_text_edit, name='admin_setting_running_text_edit'),
                    path('link/', setting.admin_index_link, name='admin_setting_link'),
                    path('links/edit/', setting.admin_index_link_edit, name='admin_setting_link_edit'),
                    path('infografis/', setting.admin_index_infografis, name='admin_setting_infografis'),
                   
                    path('me/<str:section>/', setting.admin_index_aboutme, name='admin_setting_aboutme'),
                    path('create/me/<str:section>/', setting.create_aboutme, name='admin_setting_create_aboutme'),
                    path('edit/me/<str:section>/<str:id>/', setting.edit_aboutme, name='admin_setting_edit_aboutme'),
                    path('delete/<str:section>/<str:id>/', setting.delete_aboutme, name='admin_setting_delete_aboutme'),
          
                ]
            )),

            # MASTER KATEGORI================================================
            path('kategori/', include(
                [
                    path('', categori.admin_index, name='admin_kategori'),
                    path('create/', categori.create, name='admin_kategori_create'),
                    path('edit/<str:id>/', categori.edit, name='admin_categori_edit'),
                    path('soft_delete/<str:id>/', categori.softDelete, name='admin_categori_soft_delete'),
                    path('restore/<str:id>/', categori.restore, name='admin_categori_restore'),
                    
                ]
            )),

            # MASTER TAHUN================================================
            path('tahun/', include(
                [
                    path('', tahun.admin_index, name='admin_tahun'),
                    path('create/', tahun.create, name='admin_tahun_create'),
                    path('edit/<str:id>/', tahun.edit, name='admin_tahun_edit'),
                    path('soft_delete/<str:id>/', tahun.softDelete, name='admin_tahun_soft_delete'),
                    path('restore/<str:id>/', tahun.restore, name='admin_tahun_restore'),
                    
                ]
            )),
            # MASTER TURUNAN================================================
            path('tahapan/', include(
                [
                    path('', tahapan.indexTahapan, name='index_tahapan'),
                    path('create/', tahapan.create, name='admin_tahapan_create'),
                    path('edit/<str:id_tahapan>/', tahapan.edit, name='admin_tahapan_edit'),
                    path('soft_delete/<str:id_tahapan>/', tahapan.softDelete, name='admin_tahapan_soft_delete'),
                    path('restore/<str:id_tahapan>/', tahapan.restore, name='admin_tahapan_restore'),
                    
                ]
            )),

            # MASTER KEGIATAN================================================
            path('kegiatan/', include(
                [
                    path('', kegiatan.indexKegiatan, name='index_kegiatan'),
                    path('create/', kegiatan.create, name='admin_kegiatan_create'),
                    path('edit/<str:id_kegiatan>/', kegiatan.edit, name='admin_kegiatan_edit'),
                    path('soft_delete/<str:id_kegiatan>/', kegiatan.softDelete, name='admin_kegiatan_soft_delete'),
                    path('restore/<str:id_kegiatan>/', kegiatan.restoreKegiatan, name='admin_kegiatan_restore'),
                    path('parse-kegiatan-excel/', kegiatan.ParseKegiatanExcelViews.as_view(),name='parse_kegiatan_excel'),
                    
                ]
            )),

            # MASTER WILAYAH================================================
            path('wilayah/', include(
                [
                    path('', wilayah.admin_index, name='admin_wilayah'),
                    path('create/', wilayah.create, name='admin_wilayah_create'),
                    path('edit/<str:id>/', wilayah.edit, name='admin_wilayah_edit'),
                    path('soft_delete/<str:id>/', wilayah.softDelete, name='admin_wilayah_soft_delete'),
                    path('restore/<str:id>/', wilayah.restore, name='admin_wilayah_restore'),
                    
                ]
            )),

             # MASTER SKPD================================================
            path('opd/', include(
                [
                    path('', skpd.admin_index, name='admin_skpd'),
                    path('create/', skpd.create, name='admin_skpd_create'),
                    path('edit/<str:id>/', skpd.edit, name='admin_skpd_edit'),
                    path('soft_delete/<str:id>/', skpd.softDelete, name='admin_skpd_soft_delete'),
                    path('restore/<str:id>/', skpd.restore, name='admin_skpd_restore'),
                    
                ]
            )),

             # MASTER PERUSAHAAN================================================
            path('perusahaan/', include(
                [
                    path('', company.admin_index, name='admin_perusahaan'),
                    path('create/', company.create, name='admin_perusahaan_create'),
                    path('edit/<str:id>/', company.edit, name='admin_perusahaan_edit'),
                    path('soft_delete/<str:id>/', company.softDelete, name='admin_perusahaan_soft_delete'),
                    path('restore/<str:id>/', company.restore, name='admin_perusahaan_restore'),
                    
                ]
            )),

            # MASTER PEJABAT PENGESAH================================================
            path('pejabatpengesah/', include(
                [
                    path('', pengesah.admin_index, name='admin_pejabat_pengesah'),
                    path('create/', pengesah.create, name='admin_pejabatpengesah_create'),
                    path('edit/<str:id>/', pengesah.edit, name='admin_pejabatpengesah_edit'),
                    path('soft_delete/<str:id>/', pengesah.softDelete, name='admin_pejabat_soft_delete'),
                    path('restore/<str:id>/', pengesah.restore, name='admin_pejabat_restore'),
                    
                ]
            )),
            # MASTER PAJAK================================================
            path('pajak/', include(
                [
                    path('', pajak.admin_index, name='admin_pajak'),
                    path('create/', pajak.create, name='admin_pajak_create'),
                    path('edit/<str:id>/', pajak.edit, name='admin_pajak_edit'),
                    path('soft_delete/<str:id>/', pajak.softDelete, name='admin_pajak_soft_delete'),
                    path('restore/<str:id>/', pajak.restore, name='admin_pajak_restore'),
                    
                ]
            )),

            # MASTER PEMBAYARAN================================================
            path('masterstatuspembayaran/', include(
                [
                    path('', statuspembayaran.admin_index, name='admin_status_pembayaran'),
                    path('create/', statuspembayaran.create, name='admin_status_pembayaran_create'),
                    path('edit/<str:id>/', statuspembayaran.edit, name='admin_status_pembayaran_edit'),
                    path('soft_delete/<str:id>/', statuspembayaran.softDelete, name='admin_status_pembayaran_soft_delete'),
                    path('restore/<str:id>/', statuspembayaran.restore, name='admin_status_pembayaran_restore'),
                    
                ]
            )),
            # SPK================================================
            path('trans_spk/', include(
                [
                    path('', spk_.admin_index, name='admin_spk'),
                    path('create/', spk_.create, name='admin_spk_create'),

siapkerja/urls.py
from django.contrib import admin
from django.urls import path, include, re_path
from django.conf import settings
from django.conf.urls.static import static
from django.contrib.auth import views as auth_views
from django.views.static import serve
from django.views.generic import TemplateView

urlpatterns = [
    path('sudo_manage_panel/', admin.site.urls),
    path('accounts/reset/done/', auth_views.PasswordResetCompleteView.as_view(template_name='profile/admin/user/password/password_reset_complete.html'), name='password_reset_complete'), 
    path('accounts/', include("django.contrib.auth.urls")),
    path('ckeditor/', include('ckeditor_uploader.urls')),
    path('', include('rizq_sanjaya_app.urls')),
    path('captcha/',include("captcha.urls")),
    re_path(r'^media/(?P<path>.*)$', serve,{'document_root': settings.MEDIA_ROOT}), 
    re_path(r'^static/(?P<path>.*)$', serve,{'document_root': settings.STATIC_ROOT}),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += [
    path('<path:unknown_url>', TemplateView.as_view(template_name='404.html'), name='404'),
]

rizq_sanjaya_app/views/admin.py
from django.shortcuts import render, HttpResponse
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from rizq_sanjaya_app.decorators import is_verified
from ..forms import *
from ..models import *
from django.db import connections
from ..helpers import dictfetchall

@login_required
@is_verified()
@require_http_methods(["GET"])
def index(request):
    

    # last_month = datetime.date.today() - datetime.timedelta(days=30)
    # with connections['default'].cursor() as cursor:
    #     cursor.execute("""
    #         SELECT 
    #             DISTINCT a.browser_type as browser_type,
    #             (SELECT count(b.browser_type) FROM public.rizq_sanjaya_app_logvisitor b 
    #             WHERE b.browser_type=a.browser_type and b.device_type<>'-') as total_count
    #         FROM public.rizq_sanjaya_app_logvisitor a WHERE a.device_type<>'-';""")
    #     browsers = dictfetchall(cursor)
    # browser_labels = []
    # browser_count = []
    # for browser in browsers:
    #     browser_labels.append(browser['browser_type'])
    #     browser_count.append(browser['total_count'])
    
    # with connections['default'].cursor() as cursor:
    #     cursor.execute("""
    #         SELECT 
    #             DISTINCT a.device_type as device_type,
    #             (SELECT count(b.device_type) FROM public.rizq_sanjaya_app_logvisitor b 
    #             WHERE b.device_type=a.device_type and b.device_type<>'-') as total_count
    #         FROM public.rizq_sanjaya_app_logvisitor a WHERE a.device_type<>'-';""")
    #     devices = dictfetchall(cursor)
    # device_labels = []
    # device_count = []
    # for device in devices:
    #     device_labels.append(device['device_type'])
    #     device_count.append(device['total_count'])
    
    # with connections['default'].cursor() as cursor:
    #     cursor.execute("""
    #         SELECT d::date as tanggal,
    #             (SELECT count(id) FROM public.rizq_sanjaya_app_logvisitor b 
    #             WHERE d::date=date(waktu) and b.device_type<>'-') as total_count
    #         FROM generate_series(DATE(NOW()) - INTERVAL '14 DAYS', DATE(NOW()), '1 day'::interval) d""")
    #     dates = dictfetchall(cursor)
    # date_labels = []
    # date_count = []
    # for date in dates:
    #     date_labels.append(date['tanggal'].strftime("%d/%m/%Y"))
    #     date_count.append(date['total_count'])

    context = {
        
        'title':'Dashboard',
        # 'device_labels': device_labels,
        # 'device_count': device_count,
        # 'date_labels': date_labels,
        # 'date_count': date_count,
        # 'browser_labels': browser_labels,
        # 'browser_count': browser_count,
        # 'agendas': agendas,
    }
    return render(request, 'profile/admin/index.html', context)

rizq_sanjaya_app/views/dashboard.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db import connections
from django.db.models import Q, Count
from ..helpers import dictfetchall, get_category
from django.core.paginator import Paginator, PageNotAnInteger, EmptyPage
import os
import pprint
from django.template.loader import render_to_string
import requests



@require_http_methods(["GET"])
def index(request):
#     profilSKPD_home = ProfilSKPD.objects.exclude(typexs='Misi').values('typexs').annotate(count=Count('typexs')).order_by('typexs')
#     layanan_skpd = LayananDinas.objects.exclude(status='Draft').annotate(count=Count('typexs'))
#     news =  News.objects.filter(deleted_at = None).order_by('-id')
#     news_side_home =  News.objects.filter(deleted_at = None).order_by('-id')[:5]
#     akses_link_home = Aksesbilitas.objects.exclude(status ='Draft')
#     home_agenda = InfoTerpadu.objects.filter(typexs='agenda',status='Publish')
#     context = {
         
#          'home_news':news,
#          'home_news_side':news_side_home,
#          'home_profilSKPD':profilSKPD_home, 
#          'home_starndar_pelayanan' :layanan_skpd,
#          'home_link_external':akses_link_home,
#          'home_agenda': home_agenda,
         
       
#     }
#     return render(request, 'profile/layouts/frontend/base.html', context)
      return render(request, 'profile/admin/index.html')

rizq_sanjaya_app/templates/profile/admin/master_kegiatan/form.html
{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
<link href="{% static 'admin/plugin/jstree/jstree.bundle.css' %}" rel="stylesheet" />

<style type="text/css">
    .height-100{
        height: 100% !important;
        width: 100% !important;
    }

    .wrap{
        white-space: wrap !important;
    }
</style>
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Master Kegiatan</a></li>
            <li class="breadcrumb-item active" aria-current="page">Form Tambah Master Kegiatan</li>
        </ol>
    </nav>

    <form action="" method="POST" id="form_kegiatan" enctype="multipart/form-data">
        {% csrf_token %}
        <div class="card card-flush h-xl-100">
            <div class="card-body">
                <div class="col-8">
                    <div class="row mb-5">
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Tahapan Saat Ini</label>
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <input type="text" name="frm_tahapan_" id="frm_tahapan_" class="form-control form-control-lg form-control-solid" readonly required placeholder="Tahapan Aktif" value="{{tahapan_aktif}}">
                            <input type="hidden" name="frm_tahapan" id="frm_tahapan" class="form-control form-control-lg form-control-solid" readonly required value="{{tahapan_aktif_id}}">
                        <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback"></div></div>
                    </div>
                </div>
                <div class="col-12">
                    <div class="row">
                        <div class="col">
                            <div class="input-group mb-5 file-browser">
                                <input type="text" class="form-control browse-file" placeholder="Pilih File Excel (.xlsx) Dari Template" readonly="">
                                <label class="input-group-text btn btn-primary">
                                    Browse <input type="file" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" id="frm_file_excel" name="frm_file_excel" class="form-control file-browserinput" style="display:none;">
                                </label>
                            </div>
                            <h4><b><u>Petunjuk Import Data Kegiatan</u></b></h4>
                            <ul>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Download terlebih dahulu file template diatas atau <a class="btn btn-info btn-sm" href="">Download Template</a> </li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Isikan kolom yang tersedia pada file excel</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Ikuti petunjuk pada file excel yang sudah disediakan</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Pilih file upload melalui tombol <b><i>Browse</i></b></li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Tunggu proses upload sampai menampilkan review data</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Lalu klik import data</li>
                            </ul>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col text-right">
                            <h2>Total Anggaran: Rp. <span id="total_anggaran">0,00</span></h2>
                        </div>
                    </div>
                    <div class="row mt-2">
                        <div class="col">
                            <div id="kt_docs_jstree_basic"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="card-footer d-flex justify-content-end py-6 px-9">
                <a href="{% url 'profile:index_kegiatan' %}" class="btn btn-danger btn-active-light-primary mr-2">Batal</a>
                <button type="button" class="btn btn-success" id="btn_submit_skpd">Import</button>
            </div>
        </div>
    </form>

    <!-- <div class="card shadow mb-5">
        <div class="card-body">
            <form method ='post' enctype ="multipart/form-data" action="{% if edit %}{% url 'profile:admin_kegiatan_edit' kegiatan.id_kegiatan %} {% else %}{% url 'profile:admin_kegiatan_create' %} {% endif %} ">
                {% csrf_token %}
                <div class="row">
                    <div class="col-md-4 mt-3">
                        <div class="form-label"> Tahapan </div>
                        <input type="text" name="tahapan" class="form-control" readonly value="{{ tahapan.tahapan }}" required placeholder="Silahkan isi bagian">
                        <input type="hidden" name="id_tahapan" class="form-control" value="{{ tahapan.id_tahapan }}" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-3 mt-3">
                        <div class="form-label"> Tahun </div>
                        <input type="text" name="tahun" class="form-control" readonly value="{{ tahapan.tahun.tahun }}" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-5 mt-3">
                        <div class="form-label"> SKPD </div>
                        <select class="form-select form-control-sm form-select-solid select2 " style="width: 100%;" data-control="select2" name="skpd" aria-label="Select example" required>
                            <option value="" disabled selected>Pilih role</option>
                            {% for dt_skpd in skpd %}
                                <option {% if kegiatan.skpd.id == dt_skpd.id %}selected{% endif %} value="{{ dt_skpd.id }}">
                                    {{ dt_skpd.namaopd|title }}
                                </option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="col-md-5 mt-3">
                        <div class="form-label"> Bagian </div>
                        <input type="text" name="bagian" value="{{ kegiatan.bagian }}" class="form-control" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-7 mt-3">
                        <div class="form-label"> Program </div>
                        <input type="text" name="program" value="{{ kegiatan.program }}" class="form-control" required placeholder="Silahkan isi program">
                    </div>
                    <div class="col-md-6 mt-3">
                        <div class="form-label"> Kegiatan </div>
                        <input type="text" name="kegiatan" value="{{ kegiatan.kegiatan }}" class="form-control" required placeholder="Silahkan isi kegiatan">
                    </div>
                    <div class="col-md-6 mt-3">
                        <div class="form-label"> Sub Kegiatan </div>
                        <input type="text" name="subkegiatan" value="{{ kegiatan.sub_kegiatan }}" class="form-control" required placeholder="Silahkan isi sub kegiatan">
                    </div>
                </div>
                
                <div class="mt-3">
                    <a href="{% url 'profile:index_kegiatan' %}" class="btn btn-info" ><i class="fa fa-arrow-left px-1"></i>Kembali</a>
                    <button class="btn btn-primary" type="submit"><i class="fa fa-save"></i> Simpan</button>
                </div>
            </form>
        </div>
    </div> -->

{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
<script src="{% static 'admin/plugin/jstree/jstree.bundle.js' %}"></script>
<script type="text/javascript">
    var array_kegiatan = [];

    $('#btn_submit_skpd').click(function(){
        if(check_required($('#form_kegiatan'))){
            var formData = new FormData($("#form_kegiatan")[0]);
            submit_form(formData)
        }else{
            show_notif('Silahkan cek data yang diinputkan, beberapa data masih kosong.', 'warning');
        }
    })

    $(document).on('change', '.file-browserinput', function() {
        var input = $(this),
        numFiles = input.get(0).files ? input.get(0).files.length : 1,
        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
    input.trigger('fileselect', [numFiles, label]);

    upload_file()
    });// We can watch for our custom `fileselect` event like this

    //______File Upload
    $('.file-browserinput').on('fileselect', function(event, numFiles, label) {
            
            var input = $(this).parents('.input-group').find(':text'),
            log = numFiles > 1 ? numFiles + ' files selected' : label;
            
            if( input.length ) {
                input.val(log);
            } else {
                if( log ) alert(log);
            }
    });

    function upload_file(){
        // e.preventDefault()
        // e.stopImmediatePropagation()
        var form = $('#form_kegiatan')
        var form_ = form[0];
        var f_obj = $("input[name=frm_file_excel]").get(0).files[0];
        
        var form_data = new FormData(form_);


         $.ajax({
              type: form.attr('method'),
              headers : { "X-CSRFToken": $("input[name=csrfmiddlewaretoken]").val() },
              url: "{% url 'profile:parse_kegiatan_excel' %}",
              data: form_data,
              cache: false,
              contentType: false,
              processData: false,
              dataType: 'json',
              success: function(data)
              {
                array_kegiatan = data.data_response

                console.log(array_kegiatan)

                $('#kt_docs_jstree_basic').jstree("destroy").empty()

                $('#kt_docs_jstree_basic').jstree({
                    "core" : {
                        "data" : array_kegiatan,
                    }
                });

                $('#total_anggaran').text(to_currency_indo(data.total_anggaran))
                form_.reset();
              },
              error: function(data){
                $('#kt_docs_jstree_basic').jstree("destroy").empty() 

                $('#total_anggaran').text('0,00')

                array_kegiatan = []

                var_tbl_gagal = ''
                
                try{
                    var data_gagal = data.responseJSON.data_gagal;
                }catch(err){
                    
                }

                Swal.fire({
                    title: "Oops...",
                    type: "warning",
                    icon: 'error',
                    showCancelButton: false,
                    confirmButtonText: 'OK',
                    html: `<p>${data.responseJSON.pesan}</p>${var_tbl_gagal}`,
                    // text: 
                }, function() {
                        location.reload();
                    });
              }
         });

         // form_.reset();
    };

    function submit_form(arg){
        if(array_kegiatan.length == 0){
            console.log(arg)
            show_notif('Silahkan lakukan Import Excel terlebih dahulu.', 'warning');
            return false;
        }

        arg.append("data_kegiatan", JSON.stringify(array_kegiatan))

        $.ajax({
             type: 'POST',
             headers : { "X-CSRFToken": $("input[name=csrfmiddlewaretoken]").val() },
             url: '',
             data: arg,
             processData: false,
             contentType: false,
             dataType: 'json',
             success: function(data)
             {
                show_notif(data.message,data.status);
                if(data.status == 'success'){
                    setTimeout(function(){
                        window.location.href = `{% url 'profile:index_kegiatan' %}`;
                    }, 3000);
                }
             },
             error: function(data){
                try{
                    show_notif(data.responseJSON.message,data.responseJSON.status);
                }catch(er){
                    show_notif('Terjadi Kesalahan Server.','error');
                }
             }
        });
    }

</script>   
{% endblock scripts_bawah %}